## lapack 3.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(LAPACK Fortran)

# Configure the warning and code coverage suppression file
configure_file( 
  "${LAPACK_SOURCE_DIR}/CTestCustom.cmake.in"
  "${LAPACK_BINARY_DIR}/CTestCustom.cmake"
  COPYONLY
)

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if (UNIX)
   if ( "${CMAKE_Fortran_COMPILER}" MATCHES "ifort" )
  set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fltconsistency -fp_port" )
   endif ()
endif ()


# --------------------------------------------------

# On Windows-GNU builds try to provide MS import libraries too.
if(BUILD_SHARED_LIBS)
  include(GNUtoMS)
endif()

if(GNUtoMS)
  set(LAPACK_GNUtoMS_IMPORT ${LAPACK_SOURCE_DIR}/CMAKE/lapack-GNUtoMS.cmake)
  set(LAPACK_GNUtoMS_INSTALL "include(\${_SELF_DIR}/lapack-GNUtoMS.cmake)")
  set(LAPACK_GNUtoMS_BUILD "include(\"${LAPACK_GNUtoMS_IMPORT}\")")
endif()

macro(lapack_install_library lib)
  install(TARGETS ${lib} EXPORT lapack-targets
    ARCHIVE DESTINATION lib${LIB_SUFFIX}
    LIBRARY DESTINATION lib${LIB_SUFFIX}
    RUNTIME DESTINATION bin
  )
  if(GNUtoMS)
    install(FILES ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}/lib${lib}.lib DESTINATION lib)
  endif()
endmacro()

# --------------------------------------------------
# Testing

enable_testing()
include(CTest)
enable_testing()
# --------------------------------------------------

# Organize output files.  On Windows this also keeps .dll files next
# to the .exe files that need them, making tests easy to run.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${LAPACK_BINARY_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LAPACK_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LAPACK_BINARY_DIR}/lib)

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include( CheckLAPACKCompilerFlags )
CheckLAPACKCompilerFlags()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(TIME_FUNC NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC  ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC  ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)
set(prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
set(PKG_CONFIG_DIR ${libdir}/pkgconfig)

# --------------------------------------------------
# Precision to build
# By default all precisions are generated

option(BUILD_SINGLE "Build LAPACK Single Precision" ON)
option(BUILD_DOUBLE "Build LAPACK Double Precision" ON)
option(BUILD_COMPLEX "Build LAPACK Complex Precision" ON)
option(BUILD_COMPLEX16 "Build LAPACK Double Complex Precision" ON)
# --------------------------------------------------
# Subdirectories that need to be processed

option(USE_OPTIMIZED_BLAS "Whether or not to use an optimized BLAS library instead of included netlib BLAS" OFF)


# Check the usage of the user provided BLAS libraries
if(BLAS_LIBRARIES)
  include(CheckFortranFunctionExists)
  set(CMAKE_REQUIRED_LIBRARIES ${BLAS_LIBRARIES})
  CHECK_FORTRAN_FUNCTION_EXISTS("dgemm" BLAS_FOUND)
  unset( CMAKE_REQUIRED_LIBRARIES )
  if(BLAS_FOUND)
    message(STATUS "--> BLAS supplied by user is WORKING, will use ${BLAS_LIBRARIES}.")
  else(BLAS_FOUND)
    message(ERROR "--> BLAS supplied by user is not WORKING, CANNOT USE ${BLAS_LIBRARIES}.")
    message(ERROR "-->     Will use REFERENCE BLAS (by default)")
    message(ERROR "-->     Or Correct your BLAS_LIBRARIES entry ")
    message(ERROR "-->     Or Consider checking USE_OPTIMIZED_BLAS")
  endif(BLAS_FOUND)

# User did not provide a BLAS Library but specified to search for one
elseif( USE_OPTIMIZED_BLAS )
  find_package( BLAS )
endif (BLAS_LIBRARIES)

# Neither user specified or optimized BLAS libraries can be used
if(NOT BLAS_FOUND)
  message(STATUS "Using supplied NETLIB BLAS implementation")
  add_subdirectory(BLAS)
  set( BLAS_LIBRARIES blas )
else()
  set( CMAKE_EXE_LINKER_FLAGS 
    "${CMAKE_EXE_LINKER_FLAGS} ${BLAS_LINKER_FLAGS}" 
    CACHE STRING "Linker flags for executables" FORCE)
  set( CMAKE_MODULE_LINKER_FLAGS 
    "${CMAKE_MODULE_LINKER_FLAGS} ${BLAS_LINKER_FLAGS}" 
    CACHE STRING "Linker flags for modules" FORCE)
  set( CMAKE_SHARED_LINKER_FLAGS 
    "${CMAKE_SHARED_LINKER_FLAGS} ${BLAS_LINKER_FLAGS}" 
    CACHE STRING "Linker flags for shared libs" FORCE)
endif( NOT BLAS_FOUND )

option(USE_XBLAS "Build extended precision (needs XBLAS)" OFF)
if (USE_XBLAS)
  find_library(XBLAS_LIBRARY NAMES xblas)
endif(USE_XBLAS)
   
add_subdirectory(SRC)
if(BUILD_TESTING)
  add_subdirectory(TESTING)
endif(BUILD_TESTING)

# --------------------------------------------------
# CPACK Packaging 

SET(CPACK_PACKAGE_NAME "LAPACK")
SET(CPACK_PACKAGE_VENDOR "University of Tennessee, Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "LAPACK- Linear Algebra Package")
set(LAPACK_VERSION 3.3.1)
set(CPACK_PACKAGE_VERSION_MAJOR 3)
set(CPACK_PACKAGE_VERSION_MINOR 3)
set(CPACK_PACKAGE_VERSION_PATCH 1)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "LAPACK")
IF(WIN32 AND NOT UNIX)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\http://icl.cs.utk.edu/lapack-forum")
  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.netlib.org/lapack")
  SET(CPACK_NSIS_CONTACT "lapack@eecs.utk.edu")
  SET(CPACK_NSIS_MODIFY_PATH ON)
  SET(CPACK_NSIS_DISPLAY_NAME "LAPACK-${LAPACK_VERSION}")
  set(CPACK_PACKAGE_RELOCATABLE "true")
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_GENERATOR "TGZ")
  SET(CPACK_SOURCE_GENERATOR TGZ)
  SET(CPACK_SOURCE_PACKAGE_FILE_NAME "lapack-${LAPACK_VERSION}" )
  SET(CPACK_SOURCE_IGNORE_FILES ~$ .svn ${CPACK_SOURCE_IGNORE_FILES} )
ENDIF(WIN32 AND NOT UNIX)
INCLUDE(CPack)


# --------------------------------------------------
# By default static library
OPTION(BUILD_SHARED_LIBS "Build shared libraries" OFF )
OPTION(BUILD_STATIC_LIBS "Build static libraries" ON )
#OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON )

if( NOT BLAS_FOUND )
  export(TARGETS blas lapack FILE lapack-targets.cmake)
else( NOT BLAS_FOUND )
  export(TARGETS lapack FILE lapack-targets.cmake)
endif( NOT BLAS_FOUND )
configure_file(${LAPACK_SOURCE_DIR}/CMAKE/lapack-config-version.cmake.in
  ${LAPACK_BINARY_DIR}/lapack-config-version.cmake @ONLY)
configure_file(${LAPACK_SOURCE_DIR}/CMAKE/lapack-config-build.cmake.in
  ${LAPACK_BINARY_DIR}/lapack-config.cmake @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lapack.pc.in ${CMAKE_CURRENT_BINARY_DIR}/lapack.pc)
 install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/lapack.pc
  DESTINATION ${PKG_CONFIG_DIR}
   )

configure_file(${LAPACK_SOURCE_DIR}/CMAKE/lapack-config-install.cmake.in
  ${LAPACK_BINARY_DIR}/CMakeFiles/lapack-config.cmake @ONLY)
install(FILES
  ${LAPACK_GNUtoMS_IMPORT}
  ${LAPACK_BINARY_DIR}/CMakeFiles/lapack-config.cmake
  ${LAPACK_BINARY_DIR}/lapack-config-version.cmake
  DESTINATION lib/cmake/lapack-${LAPACK_VERSION}
  )
install(EXPORT lapack-targets
  DESTINATION lib/cmake/lapack-${LAPACK_VERSION})

=== debian/changelog ===
lapack (3.4.0-1~exp1) experimental; urgency=low

  * New upstream release
  * manpages removed and repack script updated (LP: #764445)
  * New packages liblapacke & liblapacke-dev (C library) added (LP: #767108)
  * Update the whole lapack documentation. Now uses the generated documentation
    produced by doxygen.
  * Package liblapack-doc-man introduced with the manpages of the function.
  * Remove the deprecated documentation.

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 15 Nov 2011 17:07:42 +0100

lapack (3.3.1-2) experimental; urgency=low

  * Standards-Version updated to version 3.9.2
  * Get ride of the dependency on libatlas-base-dev
  * Rename liblapack3gf package => liblapack3
  * Rename liblapack.so.3gf => liblapack.so.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 03 Sep 2011 19:55:27 +0200

=== debian/control ===
Source: lapack
Section: libs
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:  Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 7), gfortran, libblas-dev (>= 1.2-7),
 doxygen, python
Standards-Version: 3.9.2
Homepage: http://www.netlib.org/lapack/
Vcs-Svn: svn://svn.debian.org/svn/pkg-scicomp/lapack/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-scicomp/lapack/

Package: liblapack3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: liblapack.so.3gf, liblapack.so.3
Conflicts: lapack99, liblapack3gf
Replaces: lapack99, liblapack3gf
Description: library of linear algebra routines 3 - shared version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.

Package: liblapacke
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: liblapacke.so.3
Description: Library of linear algebra routines 3 - C lib shared version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains the Standard C language library for LAPACK.

Package: liblapacke-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, liblapacke (= ${binary:Version})
Description: library of linear algebra routines 3 - Headers
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains the Standard C language headers for LAPACK.

Package: liblapack-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, liblapack3 (= ${binary:Version}),
 libblas-dev | libblas-3.so
Provides: liblapack-3.so
Conflicts: lapack99-dev, lapack-dev, liblapack-3.so
Replaces: lapack99-dev, lapack-dev, liblapack-3.so
Description: library of linear algebra routines 3 - static version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.

Package: liblapack-pic
Section: libdevel
Architecture: any
Conflicts: lapack-pic, lapack3-pic
Replaces: lapack-pic, lapack3-pic
Depends: ${misc:Depends}, liblapack3 (= ${binary:Version})
Description: library of linear algebra routines 3 - static PIC version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 Normally one would want to use non-PIC code for static linking.  In
 this case, install liblapack-dev.  This package is provided for other
 packages, such as ATLAS, needing access to PIC versions of the lapack
 objects in their own build process.

Package: liblapack-test
Section: libdevel
Architecture: any
Conflicts: lapack-test,lapack3-test
Replaces: lapack-test,lapack3-test
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library of linear algebra routines 3 - testing programs
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 These testing programs have been run against the
 shared library in the lapack package.  The results have been
 collected in the files test_results.  These
 programs are provided separately here so that the user can
 test and compare alternate versions of the lapack libraries,
 such as those provided by the ATLAS packages, and the lapack
 package.

Package: liblapack-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Conflicts: lapack-doc,lapack3-doc
Replaces: lapack-doc,lapack3-doc
Description: library of linear algebra routines 3 - documentation
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains the Lapack User's Guide manual in html format.
 .
 Since version 3.4.0, the HTML documentation is generated thanks to doxygen.

Package: liblapack-doc-man
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: library of linear algebra routines 3 - documentation (manual pages)
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains the Lapack User's Guide manual in man format.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SO:=3
MN:=0
VERS:=$(SO).$(MN)

GCC:=gcc

ARCH:=$(shell dpkg --print-architecture)
F77:=gfortran
FOPTS:= #-ff90
#OPTOPTS:=-g
#UNROLL:=
OPTOPTS:=-g -O3 -Wall
UNROLL:=-funroll-all-loops
ifneq (,$(filter $(ARCH), arm armel))
  OPTOPTS:=-g -O0
  UNROLL:=
endif

ifneq (,$(filter $(ARCH), m68k))
  #FOPTS:=-ffloat-store
  UNROLL:=
endif

ifeq ($(ARCH),alpha)
  FOPTS:=-mieee
endif

ifeq ($(ARCH),s390)
  OPTOPTS:=-g -O0
endif

ifneq (,$(filter $(ARCH), none))
  export ignore_testing_failures = -
endif

doc: 
	$(MAKE) html
	$(MAKE) man

#
#
# Configure
#
#

make.inc: install/make.inc.gfortran
	cat $< | sed -e "s,g77,$(F77),g" \
		     -e "s,\(^NOOPT  *=\),\1 \$$(PICOPTS) $(FOPTS),1" \
		     -e "s,-O3,\$$(PICOPTS) $(FOPTS) $(OPTOPTS),1" \
		     -e "s,\(^OPTS  *=\).*,\1 $(UNROLL) \$$(PICOPTS) $(OPTOPTS),1" \
		     -e "s,[^ ]*blas[^ ]*\.a,-lblas,1" \
		     -e "s,TIMER. *,#&," > $@
	echo "TIMER = INT_ETIME" >> $@

TIMEOUT:=1800

testing/Makefile.ori:
	cp testing/Makefile $@

testing/Makefile: testing/Makefile.ori
	cat $< | sed -e "s,\./x,$(ignore_testing_failures)../debian/trun $(TIMEOUT) ./x,g" >$@

#
#
# Build rules for libraries
#
#


liblapack_pic.a: make.inc testing/Makefile
	echo "Building liblapack_pic.a"
	$(MAKE) cleanlib
	$(MAKE) lapack_install PICOPTS=-fPIC
	$(MAKE) lib        PICOPTS=-fPIC
	mv liblapack.a $@

liblapack.so.$(VERS): liblapack_pic.a 
	echo "Building liblapack.so.$(VERS) from liblapack_pic.a"
	mkdir -p tmp
	cd tmp && ar x ../$<
	$(F77) -shared -Wl,-soname=liblapack.so.$(SO) -o $@ tmp/*.o  -L. -lblas
	rm -rf tmp

liblapack.so.$(SO): liblapack.so.$(VERS)
	ln -snf $< $@

liblapack.so: liblapack.so.$(SO)
	ln -snf $< $@

liblapack.a: make.inc testing/Makefile
	echo "Building liblapack.a"
	$(MAKE) lapack_install
	$(MAKE) lib
#	mv lapack_LINUX.a $@

liblapacke_pic.a: make.inc testing/Makefile
	echo "Building liblapacke_pic.a"
	cd lapacke; \
	$(MAKE) cleanlib; \
	$(MAKE) CFLAGS="$(OPTOPTS) -fPIC"; \
	mv lapacke.a $@


liblapacke.so.$(VERS): liblapacke_pic.a 
	echo "Building liblapacke.so.$(VERS) from liblapacke_pic.a"
	cd lapacke; \
	mkdir -p tmp; \
	cd tmp && ar x ../$< && cd -; \
	$(GCC) -shared -Wl,-soname=liblapacke.so.$(SO) -o $@ tmp/*.o  -L. -lblas -llapack; \
	rm -rf tmp

liblapacke.so.$(SO): liblapacke.so.$(VERS)
	cd lapacke; \
	ln -snf $< $@

liblapacke.so: liblapacke.so.$(SO)
	cd lapacke; \
	ln -snf $< $@

liblapacke.a: make.inc testing/Makefile
	echo "Building liblapacke.a"
	cd lapacke; \
	$(MAKE) CFLAGS="$(OPTOPTS)"; \
	mv lapacke.a $@

BF:=liblapack.a liblapack_pic.a liblapack.so  liblapacke.a  liblapacke_pic.a liblapacke.so 
build: $(BF) make.inc


#
#
# Testing rules
#
#

TB:=s d c z
TB:=$(addprefix tst,$(TB))
TB:=$(addprefix eig,$(TB)) $(addprefix lin,$(TB))
TB:=$(addprefix testing/x,$(TB))
TESF:=cbak cbal cbb cec ced cgbak cgbal cgd cgg cglm cgqr cgsv\
	clse cnep csb csep csg csvd ctest dbak dbal dbb dec ded\
	dgbak dgbal dgd dgg dglm dgqr dgsv dlse dnep dsb dsep dsg\
	dsvd dtest sbak sbal sbb sec sed sgbak sgbal sgd sgg sglm\
	sgqr sgsv slse snep ssb ssep ssg ssvd stest zbak zbal zbb\
	zec zed zgbak zgbal zgd zgg zglm zgqr zgsv zlse znep zsb\
	zsep zsg zsvd ztest

#
# Work around for alpha, cgqr test fails to converge
#
# Now fixed
#
# FIXME: filtering here has no effect; all tests are run.
#ifeq ($(ARCH),alpha)
#  TESF:=$(filter-out cgqr,$(TESF))
#endif

TESF:=$(addprefix testing/,$(addsuffix .out,$(TESF)))

$(TB) $(TESF):  liblapack.so
	chmod +x debian/trun
	grep -q debian/trun testing/Makefile \
	    || sed -i -e "s,\./x,$(ignore_testing_failures)../debian/trun $(TIMEOUT) ./x,g" testing/Makefile
	$(ignore_testing_failures)LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH \
	    $(MAKE) PICOPTS= \
		LLIB="-L $$(pwd) -llapack -lblas" lapack_testing & \
		j=$$! ;\
		tail -f --pid=$$j --retry $(TESF) & \
		wait $$j


$(subst testing,debian/test,$(TESF)):\
	debian/test/%: testing/%
	mkdir -m 777 -p $(@D)
	echo Test file $(@F) >$@
	cat $< >> $@

debian/test_results: $(subst testing,debian/test,$(TESF))
	echo "These libraries and tests were compiled with:" >$@
	$(F77) -v >>$@
	cat $^ >>$@

debian/liblapack3gf.templates: debian/test_results
	cp debian/main_templates $@
#	chmod +x debian/rawk
#	cat $^ | debian/rawk >>$@ ; j=$$? ; echo Warning level: $$j;\
		cat debian/liblapack3gf.config | sed "s,^STAT=.,STAT=$$j,1" >tmp && \
		mv tmp debian/liblapack3gf.config
#	cat $@ debian/liblapack3gf.config

#
#
# Install
#
#

debian/tmp/usr/lib/lapack/%: %
	dh_testdir
	dh_testroot

	install -m 755 -d $(@D)
	[ -L $* ] || install -m 644 $< $(@D)
	! [ -L $* ] || cp -d $< $@

$(addprefix debian/tmp/usr/lib/liblapack3gf/,$(subst testing/,,$(TB))): \
	debian/tmp/usr/lib/liblapack3gf/%: testing/%
	dh_testdir
	dh_testroot

	install -m 755 -d $(@D)
	install -m 755 $< $(@D)


#IF:=$(addprefix liblapack.,a so so.$(SO) so.$(VERS)) liblapack_pic.a
#IF:=$(addprefix debian/tmp/usr/lib/lapack/,$(IF))
#IF:=$(IF) $(addprefix debian/tmp/usr/lib/liblapack3gf/,$(subst testing/,,$(TB)))

install: $(IF) $(MF3) debian/test_results debian/liblapack3gf.templates
	dh_testdir
	dh_testroot
#	dh_movefiles


#
#
# Clean
#
#


clean:: make.inc
	dh_testdir
	dh_testroot
	rm -rf debian/*_stamp debian/*_results lib* testing/*out
#	find man -name "*.$(MANEXT)" -exec rm {} \;
	rm -rf *.a install/test* debian/test/ debian/time/
	rm -f debian/test_results debian/liblapack3gf.templates
	rm -f testing/tmp
	cd lapacke && $(MAKE) clean
	touch TESTING/xlinfoo TESTING/xeigfoo  && $(MAKE) clean
	rm -f make.inc

	-[ -e testing/Makefile.ori ] \
		&& mv testing/Makefile.ori testing/Makefile

	dh_clean

#
#
# Package rules
#
#


# Build architecture-independent files here.
binary-indep: doc install
	dh_testdir -i
	dh_testroot -i
	dh_install -i
	dh_installdocs -i
	dh_installexamples -i
	dh_installman -i -pliblapack-doc
	dh_installchangelogs -i
	dh_link -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_makeshlibs -i -n
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_install -a
	dh_installdocs -a
	dh_installdebconf -a
	dh_installexamples -a
	dh_installman -a -pliblapack-test
	dh_installchangelogs -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a -l $$(pwd)
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: clean binary-indep binary-arch binary \
	doc build

## lapack 3.4.1

=== debian/changelog ===
lapack (3.4.1-6) unstable; urgency=low

  * Ship liblapacke.so* in /usr/lib instead of /usr/lib/lapack. There is
    no reason to ship that library in a deeper directory since it is not
    managed by the lapack alternative. (Closes: #685312)

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Tue, 21 Aug 2012 08:34:48 +0000

lapack (3.4.1-5) unstable; urgency=low

  * liblapack-test: move to devel/extra, to reflect override
  * liblapacke_no_matgen.patch: new patch; prevents inclusion of wrappers
    for MATGEN functions in liblapacke (Closes: #680428)
  * liblapack-doc: add missing "Files" field in doc-base entry

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Fri, 06 Jul 2012 11:03:55 +0000

lapack (3.4.1-4) unstable; urgency=low

  * liblapack3.prerm, liblapack3gf.prerm: avoid crash if liblapack.so.3gf
    already deleted
  * liblapack3gf transitional package:
    + move to oldlibs section (Closes: #679103)
    + mark as arch:all
  * Restore alternatives in shlibs file of liblapack3
  * Set DM-Upload-Allowed to yes

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Wed, 20 Jun 2012 12:36:04 +0000

lapack (3.4.1-3) unstable; urgency=low

  [ Sylvestre Ledru ]
  * Remove debug messages

  [ Sébastien Villemot ]
  * Remove lsame(3) from liblapack-doc-man (Closes: #677461)
  * Add myself to Uploaders

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Sun, 17 Jun 2012 12:01:30 +0000

lapack (3.4.1-2) unstable; urgency=low

  [ Sylvestre Ledru ]
  * Update of Vcs-Svn and Vcs-Browser tags (Closes: #676281)
  
  [ Sébastien Villemot ]
  * Do not ship blas manpages in liblapack-doc-man (Closes: #677461)
  * Fix linking problem of liblapacke (Closes: #676528)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 05 Jun 2012 22:23:50 +0200

lapack (3.4.1-1) unstable; urgency=low

  * Upload in unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 02 Jun 2012 17:32:17 +0200

lapack (3.4.1-1~exp5) experimental; urgency=low

  * Fix a bad alternative link to the old library name 

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 01 Jun 2012 10:27:50 +0200

lapack (3.4.1-1~exp4) experimental; urgency=low

  * Replaces and Breaks updated against the right versions of other impacted
    packages
  * Force the right version to build against libblas-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 20 May 2012 17:21:13 +0200

lapack (3.4.1-1~exp3) experimental; urgency=low

  * Moved removal from postinst to preinst

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 18 May 2012 16:05:45 +0200

lapack (3.4.1-1~exp2) experimental; urgency=low

  * Remove liblapack.so.3gf references before the install

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 May 2012 18:44:11 +0200

lapack (3.4.1-1~exp1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 21 Apr 2012 17:45:44 +0200

lapack (3.4.0-1~exp3) experimental; urgency=low

  * Join modifications with blas, lapack, atlas and openblas.
    Declare the replacements of all *3gf blas & lapack implementation
    (Closes: #660607)
  * Standards-Version updated to version 3.9.3
  * graphviz is also a build dep

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 10 Apr 2012 19:35:10 +0200

lapack (3.4.0-1~exp2) experimental; urgency=low

  * Introduce back liblapack3gf as transitionnal package
    (Closes: #656039)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 19 Feb 2012 11:34:47 +0100

## lapack 3.4.1+dfsg

=== debian/changelog ===
lapack (3.4.1+dfsg-1+deb70u1) stable; urgency=low

  * recursive.patch: fix some routines which produce incorrect results in
    multithreaded environment. Thanks to Michael Banck for the fix
    (Closes: #693269)

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 07 May 2013 22:38:47 +0200

lapack (3.4.1+dfsg-1) unstable; urgency=low

  * Repackage upstream tarball. Delete non-DFSG-free files:
    lapacke/examples/example_{D,Z}GESV_rowmajor.c. (Closes: #703916)

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 25 Mar 2013 21:39:13 +0100

=== debian/rules ===
--- 
+++ 
@@ -103,7 +103,7 @@
 	cd lapacke; \
 	$(MAKE) cleanlib; \
 	$(MAKE) CFLAGS="$(OPTOPTS) -fPIC"; \
-	mv lapacke.a $@
+	mv ../liblapacke.a $@
 
 
 liblapacke.so.$(VERS): liblapacke_pic.a 
@@ -111,7 +111,7 @@
 	cd lapacke; \
 	mkdir -p tmp; \
 	cd tmp && ar x ../$< && cd -; \
-	$(GCC) -shared -Wl,-soname=liblapacke.so.$(SO) -o $@ tmp/*.o  -L. -lblas -llapack; \
+	$(GCC) -shared -Wl,-soname=liblapacke.so.$(SO) -o $@ tmp/*.o  -L.. -lblas -llapack; \
 	rm -rf tmp
 
 liblapacke.so.$(SO): liblapacke.so.$(VERS)
@@ -126,7 +126,6 @@
 	echo "Building liblapacke.a"
 	cd lapacke; \
 	$(MAKE) CFLAGS="$(OPTOPTS)"; \
-	mv lapacke.a $@
 
 BF:=liblapack.a liblapack_pic.a liblapack.so  liblapacke.a  liblapacke_pic.a liblapacke.so 
 build: $(BF) make.inc
@@ -267,6 +266,7 @@
 	dh_installman -i -pliblapack-doc
 	dh_installchangelogs -i
 	dh_link -i
+	dh_lintian -i
 	dh_strip -i
 	dh_compress -i
 	dh_fixperms -i
@@ -288,10 +288,12 @@
 	dh_installman -a -pliblapack-test
 	dh_installchangelogs -a
 	dh_link -a
+	dh_lintian -a
 	dh_strip -a
 	dh_compress -a
 	dh_fixperms -a
-	dh_makeshlibs -a
+	dh_makeshlibs -a -pliblapack3 -V "liblapack3 | liblapack.so.3 | libatlas3-base" -n
+	dh_makeshlibs -a -Nliblapack3
 	dh_installdeb -a
 	dh_shlibdeps -a -l $$(pwd)
 	dh_gencontrol -a

=== debian/watch ===
version=3
# downloadurlmangle and filenamemangle are mandatory because the lapack website
# of the full version doesn't contain the version in the name
# Then, we get the right version from the lite version of lapack but we 
# download the full one.
opts=pasv,dversionmangle=s/\+dfsg$// \
ftp://netlib.org/lapack/ lapack-([\d\.]+)\.tgz debian debian/orig-tar.sh

## lapack 3.4.2

=== debian/changelog ===
lapack (3.4.2-1~exp3) experimental; urgency=low

  * Build-arch target was not working

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 29 Sep 2012 20:14:59 +0200

lapack (3.4.2-1~exp2) experimental; urgency=low

  * Remove an override of a rule which was failing all builds

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 29 Sep 2012 09:56:28 +0200

lapack (3.4.2-1~exp1) experimental; urgency=low

  * New upstream release
  * Decouple the build process from gcc (use /usr/bin/cc instead of gcc)
  * Remove the warning no-debconf-templates
  * Fix package-would-benefit-from-build-arch-targets
  * Remove some old comments
  * Introduce some of the hardening flags

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 26 Sep 2012 07:22:36 +0200

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,35 @@
 Section: libs
 Priority: optional
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders:  Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 7), gfortran, libblas-dev (>= 1.2-7),
- doxygen, python
-Standards-Version: 3.9.2
+Uploaders: Sylvestre Ledru <sylvestre@debian.org>,
+           Sébastien Villemot <sebastien.villemot@ens.fr>
+DM-Upload-Allowed: yes
+Build-Depends: debhelper (>= 7), gfortran, libblas-dev (>= 1.2.20110419-3),
+ doxygen, python, graphviz
+Standards-Version: 3.9.3
 Homepage: http://www.netlib.org/lapack/
-Vcs-Svn: svn://svn.debian.org/svn/pkg-scicomp/lapack/
-Vcs-Browser: http://svn.debian.org/viewsvn/pkg-scicomp/lapack/
+Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/lapack/
+Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/lapack/
 
 Package: liblapack3
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Provides: liblapack.so.3gf, liblapack.so.3
-Conflicts: lapack99, liblapack3gf
-Replaces: lapack99, liblapack3gf
-Description: library of linear algebra routines 3 - shared version
+Provides: liblapack.so.3gf, liblapack.so.3, liblapack3gf
+Replaces: libatlas3gf-base (<< 3.8.4-4), liblapack3gf (<< 3.4.1-1)
+Breaks: libatlas3gf-base (<< 3.8.4-4), liblapack3gf (<< 3.4.1-1)
+Description: Library of linear algebra routines 3 - shared version
+ LAPACK version 3.X is a comprehensive FORTRAN library that does
+ linear algebra operations including matrix inversions, least
+ squared solutions to linear sets of equations, eigenvector
+ analysis, singular value decomposition, etc. It is a very
+ comprehensive and reputable package that has found extensive
+ use in the scientific community.
+
+Package: liblapack3gf
+Architecture: all
+Section: oldlibs
+Depends: ${misc:Depends}, liblapack3
+Description: Transitional package for liblapack3
  LAPACK version 3.X is a comprehensive FORTRAN library that does
  linear algebra operations including matrix inversions, least
  squared solutions to linear sets of equations, eigenvector
@@ -42,7 +56,7 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, liblapacke (= ${binary:Version})
-Description: library of linear algebra routines 3 - Headers
+Description: Library of linear algebra routines 3 - Headers
  LAPACK version 3.X is a comprehensive FORTRAN library that does
  linear algebra operations including matrix inversions, least
  squared solutions to linear sets of equations, eigenvector
@@ -58,9 +72,7 @@
 Depends: ${misc:Depends}, liblapack3 (= ${binary:Version}),
  libblas-dev | libblas-3.so
 Provides: liblapack-3.so
-Conflicts: lapack99-dev, lapack-dev, liblapack-3.so
-Replaces: lapack99-dev, lapack-dev, liblapack-3.so
-Description: library of linear algebra routines 3 - static version
+Description: Library of linear algebra routines 3 - static version
  LAPACK version 3.X is a comprehensive FORTRAN library that does
  linear algebra operations including matrix inversions, least
  squared solutions to linear sets of equations, eigenvector
@@ -74,7 +86,7 @@
 Conflicts: lapack-pic, lapack3-pic
 Replaces: lapack-pic, lapack3-pic
 Depends: ${misc:Depends}, liblapack3 (= ${binary:Version})
-Description: library of linear algebra routines 3 - static PIC version
+Description: Library of linear algebra routines 3 - static PIC version
  LAPACK version 3.X is a comprehensive FORTRAN library that does
  linear algebra operations including matrix inversions, least
  squared solutions to linear sets of equations, eigenvector
@@ -88,12 +100,13 @@
  objects in their own build process.
 
 Package: liblapack-test
-Section: libdevel
+Section: devel
+Priority: extra
 Architecture: any
-Conflicts: lapack-test,lapack3-test
-Replaces: lapack-test,lapack3-test
+Conflicts: lapack-test, lapack3-test
+Replaces: lapack-test, lapack3-test
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: library of linear algebra routines 3 - testing programs
+Description: Library of linear algebra routines 3 - testing programs
  LAPACK version 3.X is a comprehensive FORTRAN library that does
  linear algebra operations including matrix inversions, least
  squared solutions to linear sets of equations, eigenvector
@@ -113,9 +126,9 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
-Conflicts: lapack-doc,lapack3-doc
-Replaces: lapack-doc,lapack3-doc
-Description: library of linear algebra routines 3 - documentation
+Conflicts: lapack-doc, lapack3-doc
+Replaces: lapack-doc, lapack3-doc
+Description: Library of linear algebra routines 3 - documentation
  LAPACK version 3.X is a comprehensive FORTRAN library that does
  linear algebra operations including matrix inversions, least
  squared solutions to linear sets of equations, eigenvector
@@ -131,7 +144,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
-Description: library of linear algebra routines 3 - documentation (manual pages)
+Description: Library of linear algebra routines 3 - documentation (manual pages)
  LAPACK version 3.X is a comprehensive FORTRAN library that does
  linear algebra operations including matrix inversions, least
  squared solutions to linear sets of equations, eigenvector
@@ -140,4 +153,3 @@
  use in the scientific community.
  .
  This package contains the Lapack User's Guide manual in man format.
-

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 MN:=0
 VERS:=$(SO).$(MN)
 
-GCC:=gcc
+CC:=/usr/bin/cc
 
 ARCH:=$(shell dpkg --print-architecture)
 F77:=gfortran
@@ -83,7 +83,7 @@
 	echo "Building liblapack.so.$(VERS) from liblapack_pic.a"
 	mkdir -p tmp
 	cd tmp && ar x ../$<
-	$(F77) -shared -Wl,-soname=liblapack.so.$(SO) -o $@ tmp/*.o  -L. -lblas
+	$(F77) -shared -Wl,-soname=liblapack.so.$(SO) -o $@ tmp/*.o  -L. -lblas $(shell dpkg-buildflags --get LDFLAGS)
 	rm -rf tmp
 
 liblapack.so.$(SO): liblapack.so.$(VERS)
@@ -102,7 +102,7 @@
 	echo "Building liblapacke_pic.a"
 	cd lapacke; \
 	$(MAKE) cleanlib; \
-	$(MAKE) CFLAGS="$(OPTOPTS) -fPIC"; \
+	$(MAKE) CFLAGS="$(OPTOPTS) -fPIC $(shell dpkg-buildflags --get CFLAGS)"; \
 	mv ../liblapacke.a $@
 
 
@@ -111,7 +111,7 @@
 	cd lapacke; \
 	mkdir -p tmp; \
 	cd tmp && ar x ../$< && cd -; \
-	$(GCC) -shared -Wl,-soname=liblapacke.so.$(SO) -o $@ tmp/*.o  -L.. -lblas -llapack; \
+	$(CC) -shared -Wl,-soname=liblapacke.so.$(SO) -o $@ tmp/*.o  -L.. -lblas -llapack $(shell dpkg-buildflags --get LDFLAGS); \
 	rm -rf tmp
 
 liblapacke.so.$(SO): liblapacke.so.$(VERS)
@@ -125,11 +125,9 @@
 liblapacke.a: make.inc testing/Makefile
 	echo "Building liblapacke.a"
 	cd lapacke; \
-	$(MAKE) CFLAGS="$(OPTOPTS)"; \
-
-BF:=liblapack.a liblapack_pic.a liblapack.so  liblapacke.a  liblapacke_pic.a liblapacke.so 
-build: $(BF) make.inc
-
+	$(MAKE) CFLAGS="$(OPTOPTS) $(shell dpkg-buildflags --get CFLAGS)"; \
+
+BF:=liblapack.a liblapack_pic.a liblapack.so  liblapacke.a  liblapacke_pic.a liblapacke.so
 
 #
 #
@@ -149,16 +147,6 @@
 	zec zed zgbak zgbal zgd zgg zglm zgqr zgsv zlse znep zsb\
 	zsep zsg zsvd ztest
 
-#
-# Work around for alpha, cgqr test fails to converge
-#
-# Now fixed
-#
-# FIXME: filtering here has no effect; all tests are run.
-#ifeq ($(ARCH),alpha)
-#  TESF:=$(filter-out cgqr,$(TESF))
-#endif
-
 TESF:=$(addprefix testing/,$(addsuffix .out,$(TESF)))
 
 $(TB) $(TESF):  liblapack.so
@@ -186,11 +174,6 @@
 
 debian/liblapack3gf.templates: debian/test_results
 	cp debian/main_templates $@
-#	chmod +x debian/rawk
-#	cat $^ | debian/rawk >>$@ ; j=$$? ; echo Warning level: $$j;\
-		cat debian/liblapack3gf.config | sed "s,^STAT=.,STAT=$$j,1" >tmp && \
-		mv tmp debian/liblapack3gf.config
-#	cat $@ debian/liblapack3gf.config
 
 #
 #
@@ -200,7 +183,6 @@
 
 debian/tmp/usr/lib/lapack/%: %
 	dh_testdir
-	dh_testroot
 
 	install -m 755 -d $(@D)
 	[ -L $* ] || install -m 644 $< $(@D)
@@ -209,20 +191,13 @@
 $(addprefix debian/tmp/usr/lib/liblapack3gf/,$(subst testing/,,$(TB))): \
 	debian/tmp/usr/lib/liblapack3gf/%: testing/%
 	dh_testdir
-	dh_testroot
 
 	install -m 755 -d $(@D)
 	install -m 755 $< $(@D)
 
 
-#IF:=$(addprefix liblapack.,a so so.$(SO) so.$(VERS)) liblapack_pic.a
-#IF:=$(addprefix debian/tmp/usr/lib/lapack/,$(IF))
-#IF:=$(IF) $(addprefix debian/tmp/usr/lib/liblapack3gf/,$(subst testing/,,$(TB)))
-
 install: $(IF) $(MF3) debian/test_results debian/liblapack3gf.templates
 	dh_testdir
-	dh_testroot
-#	dh_movefiles
 
 
 #
@@ -234,7 +209,6 @@
 
 clean:: make.inc
 	dh_testdir
-	dh_testroot
 	rm -rf debian/*_stamp debian/*_results lib* testing/*out
 #	find man -name "*.$(MANEXT)" -exec rm {} \;
 	rm -rf *.a install/test* debian/test/ debian/time/
@@ -254,12 +228,14 @@
 # Package rules
 #
 #
-
+build: $(BF) make.inc build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
+build-stamp: $(BF) make.inc
 
 # Build architecture-independent files here.
 binary-indep: doc install
 	dh_testdir -i
-	dh_testroot -i
 	dh_install -i
 	dh_installdocs -i
 	dh_installexamples -i
@@ -280,10 +256,8 @@
 # Build architecture-dependent files here.
 binary-arch: install
 	dh_testdir -a
-	dh_testroot -a
 	dh_install -a
 	dh_installdocs -a
-	dh_installdebconf -a
 	dh_installexamples -a
 	dh_installman -a -pliblapack-test
 	dh_installchangelogs -a

## lapack 3.4.2+dfsg

=== debian/changelog ===
lapack (3.4.2+dfsg-2) unstable; urgency=low

  [ Sébastien Villemot ]
  * Bump to debhelper compat level 9
  * Simplification and improvement of debian/rules:
    + use dh
    + remove hack to workaround timeouts in testsuite
    + ship testsuite summary generated by LAPACK build system instead of
      generating our own
    + do not run testsuite if DEB_BUILD_OPTIONS contains "nocheck"
      (Closes: #718948)
    + ensure that flags from dpkg-buildflags are injected everywhere
  * Install static library in liblapacke-dev
  * Remove remnants of old system for notifying testsuite errors at
    installation of the library
  * Switch VCS to Git
  * liblapack-dev now alternatively depends on libblas.so (Closes: #695825)
  * liblapack-dev now provides liblapack.so (instead of liblapack-3.so), for
    consistency with libblas-dev
  * Do not ship a copy of jquery.js; instead link to the version from the Debian
    package
  * Fix debian/watch

  [ Julian Taylor ]
  * strip -Bsymbolic-functions from LDFLAGS. -Bsymbolic-functions breaks
    xerbla_ error handling overrides as internal calls to it will not go
    over the plt anymore. With bfd linker --dynamic-list could be used
    instead but it doesn't seem work with gold linker. (Closes: #722252)

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 14 Sep 2013 21:59:36 +0200

lapack (3.4.2+dfsg-1) unstable; urgency=low

  [ Sébastien Villemot ]
  * parallel_build.patch: improve patch by marking some Makefiles as not
    parallelizable; should fix FTBFS on kfreebsd-*

  [ Sylvestre Ledru ]
  * Upload to unstable
  * Some routines produced incorrect results in multithreaded environment
    Thanks to Michael Banck for the fix (Closes: #693269)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 06 May 2013 11:39:13 +0200

lapack (3.4.2+dfsg-1~exp1) experimental; urgency=low

  * Repackage upstream tarball. Delete non-DFSG-free files:
    lapacke/examples/example_{D,Z}GESV_rowmajor.c. (Closes: #703916)
  * Use my @debian.org email address
  * Remove obsolete DM-Upload-Allowed control flag
  * Fixes and improvements in package build logic
    + fix build-arch and build-indep rules
    + use Build-Depends-Indep field
    + enable parallel build (in particular, new patch parallel_build.patch)
    + move test failure notice from obsolete liblapack3gf to liblapack3
  * Bump Standards-Version to 3.9.4
  * Add lintian overrides in liblapack-doc-man about bad whatis entries in
    manpages (upstream does not provide the required short descriptions)

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 27 Mar 2013 13:11:24 +0100

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,15 @@
 Priority: optional
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>,
-           Sébastien Villemot <sebastien.villemot@ens.fr>
-DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 7), gfortran, libblas-dev (>= 1.2.20110419-3),
- doxygen, python, graphviz
-Standards-Version: 3.9.3
+           Sébastien Villemot <sebastien@debian.org>
+Build-Depends: debhelper (>= 9), gfortran, libblas-dev (>= 1.2.20110419-3),
+ python
+Build-Depends-Indep: doxygen, graphviz
+Standards-Version: 3.9.4
 Homepage: http://www.netlib.org/lapack/
-Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/lapack/
-Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/lapack/
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/lapack.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/lapack.git
+XS-Testsuite: autopkgtest
 
 Package: liblapack3
 Architecture: any
@@ -70,8 +71,8 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, liblapack3 (= ${binary:Version}),
- libblas-dev | libblas-3.so
-Provides: liblapack-3.so
+ libblas-dev | libblas.so
+Provides: liblapack.so
 Description: Library of linear algebra routines 3 - static version
  LAPACK version 3.X is a comprehensive FORTRAN library that does
  linear algebra operations including matrix inversions, least
@@ -125,7 +126,7 @@
 Package: liblapack-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, libjs-jquery
 Conflicts: lapack-doc, lapack3-doc
 Replaces: lapack-doc, lapack3-doc
 Description: Library of linear algebra routines 3 - documentation

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SO:=3
MN:=0
VERS:=$(SO).$(MN)

# xerblas_ and LAPACK_xerblas must be overrideable by applications
# --dynamic-list does not work with gold, so drop the flag completely
BUILDFLAGS_ENV:=DEB_LDFLAGS_MAINT_STRIP="-Wl,-Bsymbolic-functions"
LDFLAGS:=$(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)

F77:=gfortran
FFLAGS:=$(shell dpkg-buildflags --get FFLAGS) -funroll-all-loops
FFLAGS_NOOPT:=$(shell DEB_BUILD_OPTIONS=noopt dpkg-buildflags --get FFLAGS)

CC:=/usr/bin/cc
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)

ARCH:=$(shell dpkg --print-architecture)

ifeq ($(ARCH),alpha)
  FFLAGS += -mieee
  FFLAGS_NOOPT += -mieee
endif

# Support parallel build
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

#
#
# Configure
#
#

make.inc: install/make.inc.gfortran
	cat $< | sed -e "s,\(^NOOPT  *=\).*,\1 \$$(PICOPTS) $(FFLAGS_NOOPT),1" \
		     -e "s,\(^OPTS  *=\).*,\1 \$$(PICOPTS) $(FFLAGS),1" \
		     -e "s/\(^LOADOPTS  *=\).*/\1 $(LDFLAGS)/1" \
		     -e "s,\(^CFLAGS  *=\).*,\1 $(CPPFLAGS) \$$(PICOPTS) $(CFLAGS),1" \
		     -e "s,[^ ]*blas[^ ]*\.a,-lblas,1" > $@

#
#
# Build rules for libraries
#
#

liblapack_pic.a: make.inc testing/Makefile
	echo "Building liblapack_pic.a"
	$(MAKE) cleanlib
	$(MAKE) lapack_install PICOPTS=-fPIC
	$(MAKE) lib        PICOPTS=-fPIC
	mv liblapack.a $@

liblapack.so.$(VERS): liblapack_pic.a 
	echo "Building liblapack.so.$(VERS) from liblapack_pic.a"
	mkdir -p tmp
	cd tmp && ar x ../$<
	$(F77) -shared -Wl,-soname=liblapack.so.$(SO) -o $@ tmp/*.o  -L. -lblas $(LDFLAGS)
	rm -rf tmp

liblapack.so.$(SO): liblapack.so.$(VERS)
	ln -snf $< $@

liblapack.so: liblapack.so.$(SO)
	ln -snf $< $@

liblapack.a: make.inc
	echo "Building liblapack.a"
	$(MAKE) lapack_install
	$(MAKE) lib

lapacke/liblapacke_pic.a: make.inc
	echo "Building liblapacke_pic.a"
	cd lapacke; \
	$(MAKE) cleanlib; \
	$(MAKE) PICOPTS=-fPIC; \
	mv ../liblapacke.a $(@F)

lapacke/liblapacke.so.$(VERS): lapacke/liblapacke_pic.a 
	echo "Building liblapacke.so.$(VERS) from liblapacke_pic.a"
	cd lapacke; \
	mkdir -p tmp; \
	cd tmp && ar x ../$(<F) && cd -; \
	$(CC) -shared -Wl,-soname=liblapacke.so.$(SO) -o $(@F) tmp/*.o  -L.. -lblas -llapack $(LDFLAGS); \
	rm -rf tmp

lapacke/liblapacke.so.$(SO): lapacke/liblapacke.so.$(VERS)
	cd lapacke; \
	ln -snf $(<F) $(@F)

lapacke/liblapacke.so: lapacke/liblapacke.so.$(SO)
	cd lapacke; \
	ln -snf $(<F) $(@F)

lapacke/liblapacke.a: make.inc
	echo "Building liblapacke.a"
	cd lapacke; \
	$(MAKE) ; \
	mv ../liblapacke.a $(@F)

#
#
# Testing rules
#
#

testing/testing_results.txt: liblapack.so
	LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH \
		$(MAKE) PICOPTS= \
		LLIB="-L $$(pwd) -llapack -lblas" lapack_testing

#
#
# Package rules
#
#

%:
	dh $@ --parallel

override_dh_auto_clean: make.inc
	dh_testdir
	rm -rf debian/*_stamp debian/*_results lib* testing/*out
	rm -rf *.a install/test* debian/test/ debian/time/
	rm -f testing/tmp testing/testing_results.txt
	cd lapacke && $(MAKE) clean
	rm -f lapacke/*.a lapacke/*.so lapacke/*.so.* lapacke/include/lapacke_mangling.h
	touch TESTING/xlinfoo TESTING/xeigfoo  && $(MAKE) clean
	rm -rf DOCS/explore-html/ DOCS/man/
	rm -f output_err
	rm -f make.inc

# liblapack_pic.a must come before liblapack.a, otherwise the latter will be overwritten
# We also build the test programs, in order to avoid FTBFS if DEB_BUILD_OPTIONS contains nocheck
override_dh_auto_build-arch: liblapack_pic.a liblapack.a liblapack.so lapacke/liblapacke_pic.a lapacke/liblapacke.a lapacke/liblapacke.so
	make -C testing xeigtstc xeigtstd xeigtsts xeigtstz xlintstc xlintstd xlintsts xlintstz xlintstds xlintstrfc xlintstrfd xlintstrfs xlintstrfz xlintstzc

override_dh_auto_build-indep: make.inc
	$(MAKE) html
	$(MAKE) man
	ln -sf /usr/share/javascript/jquery/jquery.min.js DOCS/explore-html/jquery.js

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch: testing/testing_results.txt
else
override_dh_auto_test-arch:
	touch testing/testing_results.txt
endif

override_dh_makeshlibs:
	dh_makeshlibs -a -pliblapack3 -V "liblapack3 | liblapack.so.3" -n
	dh_makeshlibs -a -Nliblapack3

override_dh_shlibdeps:
	dh_shlibdeps -a -l $$(pwd)

# This Makefile must be run serially (because non-PIC and PIC versions must be
# built sequentially), but the sub-makes can still be parallized
.NOTPARALLEL:

=== debian/tests/control ===
Tests: xerbla-fortran
Depends: liblapack-dev, gfortran

Tests: xerbla-c
Depends: liblapacke-dev, gcc

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg$// \
http://www.netlib.org/lapack/ lapack-([\d\.]+)\.tgz debian debian/orig-tar.sh
